/*energy.java
 *2003/02/10
 *javaScript
 *2024/12/04
 *Suzuki,Tetsuo 鈴木徹夫
 */
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let pa,x,y,dx,dy,v1,v2,u1,u2,vx1,vx2,ux1,ux2,v,uu,vv;
let r,sx,sy,sr,i,l,f1,f2,f3,strobo,kaku,wa,ha;
let n=4;
let ang,k;
let d = { width: canvas.width, height: canvas.height };

function init() {
	k=1;f1=0;f2=1;f3=1;wa=25;ha=50;
	r=4;
	ang=1.0472;
    kaku=60;
    sr=150;
    sx=wa+sr;
    sy=r+ha;
	l=0;
    v=60;
	pa=1.2;
				
    x=wa+r-1;
	y=r+ha;
	dx=0;
	dy=0;
	
	buffer = createBuffer(d.width, d.height);
    drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
	const g = buffer.getContext("2d");
	
	if(f2==1){
		g.fillStyle = "white";
		g.fillRect(0,0,d.width,d.height)
		
		g.fillStyle = "orange";
		g.fillRect(0,r+ha,wa+sr+(sr*Math.sin(ang))+2,d.height-r-ha)
       	g.fillRect(0,r+ha+sr,d.width,d.height-r-ha-sr);
		
		g.fillStyle = "white";
        g.beginPath();
		g.arc(sx,sy,sr, 0, Math.PI * 2);
		g.fill();
		
       	g.strokeStyle = "cyan";
        g.beginPath();
        g.moveTo(wa,r+ha);
        g.lineTo(d.width,r+ha);
		g.moveTo(sx,sy);
        g.lineTo(sx,sy+sr);
		g.moveTo(sx,sy);
        g.lineTo(sx+(sr*Math.sin(ang)),sy+(sr*Math.cos(ang)));
        g.stroke();
         
        g.fillStyle = "blue";
        g.fillText(" "+kaku,sx+2,sy+30); 
        g.fillText("e="+k,wa+2*sr+200,sy+sr+20); 
       	f2=0;
		}
	
	    if(strobo !=1){
		g.fillStyle = "white";
		g.fillRect(0,0,d.width,d.height)
		
        g.fillStyle = "orange";
		g.fillRect(0,r+ha,wa+sr+(sr*Math.sin(ang))+2,d.height-r-ha)
       	g.fillRect(0,r+ha+sr,d.width,d.height-r-ha-sr);

        g.fillStyle = "white";
        g.beginPath();
		g.arc(sx,sy,sr, 0, Math.PI * 2);
		g.fill();

        g.strokeStyle = "cyan";
        g.beginPath();
        g.moveTo(wa,r+ha);
        g.lineTo(d.width,r+ha);
		g.moveTo(sx,sy);
        g.lineTo(sx,sy+sr);
		g.moveTo(sx,sy);
        g.lineTo(sx+(sr*Math.sin(ang)),sy+(sr*Math.cos(ang)));
        g.stroke();	
       
    	g.fillStyle = "blue";
        g.fillText(" "+kaku,sx+2,sy+30); 
        g.fillText("e="+k,wa+2*sr+200,sy+sr+20); 
        }
		
		g.fillStyle = "blue";
        g.beginPath();
		g.arc(x,y,r, 0, Math.PI * 2);
		g.fill();		
}
		
function move() {
	    let bx,by,ddx,ddy,ax,ay,aa,raa,ss,q1,q2,q3;
		dy=dy+pa*f1;
		x=x+dx*f1;
		y=y+dy*f1;
		
		if (y>sr+ha&&x>wa+sr+(sr*Math.sin(ang))){
			ss=y-sr-ha;
		 	y=sr+ha;
			dy=-k*dy-(Math.sqrt(dy*dy+((dy+pa)*(dy+pa)-dy*dy)*(dy-ss)/dy)-dy);
		    }
        ax=sx-x;
        ay=y-sy;
        aa=ax*ax+ay*ay;
         raa=Math.sqrt(aa);
	    if(raa+r>sr&&x<wa+sr+(sr*Math.sin(ang))){
	
         x=x+(raa-sr+r-1)*ax/raa;
          y=y-(raa-sr+r-1)*ay/raa;
		
			ddx=(1.0046)*dx*ay/raa+dy*ax/raa;
			ddy=(-1)*(dy*ay/raa-dx*ax/raa);
			bx=ddx*ay/raa-ddy*ax/raa;
			by=ddx*ax/raa+ddy*ay/raa;
		
			dx=bx;dy=by;
    }
        
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 30);
} 

document.getElementById('a0').addEventListener('click', a0);
document.getElementById('a30').addEventListener('click', a30);
document.getElementById('a45').addEventListener('click', a45);
document.getElementById('a60').addEventListener('click', a60);
document.getElementById('a90').addEventListener('click', a90);
document.getElementById('e1').addEventListener('click', e1);
document.getElementById('e08').addEventListener('click', e08);
document.getElementById('e05').addEventListener('click', e05);
document.getElementById('e00').addEventListener('click', e00);
document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Str').addEventListener('click', Str);
document.getElementById('Stop').addEventListener('click', Stop);


function a0() {
        ang=0;
        f1=0;kaku=0;
	    f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;					 
}
function a30() {
        ang=0.5235987;kaku=30;
        f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}
function a45() {
        ang=0.7853981;kaku=45;
        f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
	    dy=0;
}
function a60() {
        ang=1.0471975;kaku=60;
        f1=0;
		f2=1;
		f3=1;
	    strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
	    dy=0;
}
function a90() {
        ang=1.5707963;kaku=90;
        f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}
function e1() {
        k=1;
	    f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}
function e08() {
        k=0.8;
		f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
	    dy=0;
}
function e05() {
        k=0.5;
	    f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}
function e00() {
        k=0;
		f1=0;
		f2=1;
		strobo=0;
		x=wa+r-1;
		y=r+ha;
		dx=0;
	    dy=0;
}


function Run() {
        f1=1;
		f2=1;
	    strobo=0;
        x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}


function Stop() {
        f1=0;
		f2=0;
		dx=0;
	    dy=0;
}
function Str() {
        strobo=1;
        f2=1;
	    f1=1;
		x=wa+r-1;
		y=r+ha;
		dx=0;
		dy=0;
}


init();
start();




